<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/matviewstruct.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>matviewstruct.c</h1><a href="matviewstruct_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2006-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: matviewstruct.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="util_8h.html#a7c494f3571a8f64d0056e03cbf6c994a">00029</a> <span class="keywordtype">int</span> <a class="code" href="matviewstruct_8c.html#a7c494f3571a8f64d0056e03cbf6c994a">matviewstruct</a>(MPI_Comm comm,Mat mat)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   <span class="keywordtype">int</span> rank,size;
<a name="l00034"></a>00034   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00035"></a>00035   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> m,n;
<a name="l00038"></a>00038   ierr = MatGetSize(mat,&amp;m,&amp;n);CHKERRQ(ierr);
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   ierr = PetscViewerSetFormat(PETSC_VIEWER_STDOUT_SELF,PETSC_VIEWER_ASCII_INFO);CHKERRQ(ierr);
<a name="l00041"></a>00041   ierr = MatView(mat,PETSC_VIEWER_STDOUT_SELF);CHKERRQ(ierr);
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (m!=n) {
<a name="l00044"></a>00044     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Matrix not square, cannot calculate bandwidth.\n&quot;</span>);
<a name="l00045"></a>00045     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00046"></a>00046   }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">/*</span>
<a name="l00049"></a>00049 <span class="comment">  ierr = MatView(mat,PETSC_VIEWER_STDOUT_SELF);CHKERRQ(ierr);</span>
<a name="l00050"></a>00050 <span class="comment">*/</span>
<a name="l00051"></a>00051 <span class="comment">/* very slow if running in parallel</span>
<a name="l00052"></a>00052 <span class="comment">  ierr = MatView(mat,PETSC_VIEWER_DRAW_WORLD);CHKERRQ(ierr);</span>
<a name="l00053"></a>00053 <span class="comment">  MagparFunctionLogReturn(0);</span>
<a name="l00054"></a>00054 <span class="comment">*/</span>
<a name="l00055"></a>00055 <span class="preprocessor">#if 0</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>  <span class="comment">/* does not work 1 */</span>
<a name="l00057"></a>00057   Mat matloc;
<a name="l00058"></a>00058   IS  isrow,iscol;
<a name="l00059"></a>00059   ierr = MatGetSubMatrix(mat,isrow,iscol,n,MAT_INITIAL_MATRIX,&amp;matloc);CHKERRQ(ierr);
<a name="l00060"></a>00060 <span class="preprocessor">#elif 0</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>  <span class="comment">/* does not work 2 */</span>
<a name="l00062"></a>00062   <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> from,to;
<a name="l00063"></a>00063   ierr = MatGetOwnershipRange(mat,&amp;from,&amp;to);CHKERRQ(ierr);
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   IS  isrow,iscol;
<a name="l00066"></a>00066   ierr = ISCreateStride(PETSC_COMM_WORLD,to-from,from,1,&amp;isrow);CHKERRQ(ierr);
<a name="l00067"></a>00067   ierr = ISCreateStride(PETSC_COMM_WORLD,n,1,1,&amp;iscol);CHKERRQ(ierr);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   Mat matloc;
<a name="l00070"></a>00070   MatConvert(mat,MATSEQAIJ,MAT_INITIAL_MATRIX,&amp;matloc);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 <span class="comment">/* this is the problem:</span>
<a name="l00073"></a>00073 <span class="comment">[1]PETSC ERROR: MatCreate_SeqAIJ() line 2864 in src/mat/impls/aij/seq/aij.c</span>
<a name="l00074"></a>00074 <span class="comment">[1]PETSC ERROR: Argument out of range!</span>
<a name="l00075"></a>00075 <span class="comment">[1]PETSC ERROR: Comm must be of size 1!</span>
<a name="l00076"></a>00076 <span class="comment">[1]PETSC ERROR: MatSetType() line 64 in src/mat/interface/matreg.c</span>
<a name="l00077"></a>00077 <span class="comment">[1]PETSC ERROR: MatConvert() line 3141 in src/mat/interface/matrix.c</span>
<a name="l00078"></a>00078 <span class="comment">*/</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   ierr = ISDestroy(isrow);CHKERRQ(ierr);
<a name="l00081"></a>00081   ierr = ISDestroy(iscol);CHKERRQ(ierr);
<a name="l00082"></a>00082 <span class="preprocessor">#elif 0</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>  <span class="comment">/* does not work 3 */</span>
<a name="l00084"></a>00084   Mat matloc;
<a name="l00085"></a>00085   ierr = MatGetLocalMat(mat,MAT_INITIAL_MATRIX,&amp;matloc);CHKERRQ(ierr);
<a name="l00086"></a>00086 <span class="comment">/*</span>
<a name="l00087"></a>00087 <span class="comment">  ierr = MatView(matloc,PETSC_VIEWER_DRAW_WORLD);CHKERRQ(ierr);</span>
<a name="l00088"></a>00088 <span class="comment">  ierr = MatDestroy(matloc);CHKERRQ(ierr);</span>
<a name="l00089"></a>00089 <span class="comment">*/</span>
<a name="l00090"></a>00090 <span class="preprocessor">#else</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>  <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> from,to;
<a name="l00092"></a>00092   ierr = MatGetOwnershipRange(mat,&amp;from,&amp;to);CHKERRQ(ierr);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   IS  isrow,iscol;
<a name="l00095"></a>00095   ierr = ISCreateStride(comm,to-from,from,1,&amp;isrow);CHKERRQ(ierr);
<a name="l00096"></a>00096   ierr = ISCreateStride(comm,n,1,1,&amp;iscol);CHKERRQ(ierr);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   Mat *submatloc;
<a name="l00099"></a>00099   ierr = MatGetSubMatrices(mat,1,&amp;isrow,&amp;iscol,MAT_INITIAL_MATRIX,&amp;submatloc);CHKERRQ(ierr);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   ierr = ISDestroy(isrow);CHKERRQ(ierr);
<a name="l00102"></a>00102   ierr = ISDestroy(iscol);CHKERRQ(ierr);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   Mat matloc;
<a name="l00105"></a>00105   matloc=submatloc[0];
<a name="l00106"></a>00106 <span class="preprocessor">#endif</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span>
<a name="l00108"></a>00108   <span class="comment">/* calculate bandwidth */</span>
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> *ia,*ja;
<a name="l00111"></a>00111   PetscTruth done;
<a name="l00112"></a>00112   ierr = MatGetRowIJ(matloc,0,PETSC_TRUE,PETSC_FALSE,&amp;from,&amp;ia,&amp;ja,&amp;done);CHKERRQ(ierr);
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="comment">/* assume that we get useful data back (not true on 2nd,...,nth processor)</span>
<a name="l00115"></a>00115 <span class="comment">  assert(done==PETSC_TRUE);</span>
<a name="l00116"></a>00116 <span class="comment">*/</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">/* assume square matrix, no I-nodes used */</span>
<a name="l00119"></a>00119   <span class="keywordtype">int</span> cmin,cmax,bw,bwmax;
<a name="l00120"></a>00120   bwmax=0;
<a name="l00121"></a>00121   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;m;i++) {
<a name="l00122"></a>00122     cmin=m;
<a name="l00123"></a>00123     cmax=0;
<a name="l00124"></a>00124     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;(ia[i+1]-ia[i]);j++) {
<a name="l00125"></a>00125       cmin=PetscMin(cmin,ja[ia[i]+j]);
<a name="l00126"></a>00126       cmax=PetscMax(cmax,ja[ia[i]+j]);
<a name="l00127"></a>00127     }
<a name="l00128"></a>00128     bw=cmax-cmin+1;
<a name="l00129"></a>00129     <span class="keywordflow">if</span> (bw &gt; bwmax) {
<a name="l00130"></a>00130       bwmax=bw;
<a name="l00131"></a>00131       n=i;
<a name="l00132"></a>00132     }
<a name="l00133"></a>00133   }
<a name="l00134"></a>00134   PetscPrintf(comm,<span class="stringliteral">&quot;max. bandwidth: %i in row %i (of %i)\n&quot;</span>,bwmax,n,m);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   ierr = MatRestoreRowIJ(matloc,0,PETSC_TRUE,PETSC_FALSE,&amp;from,&amp;ia,&amp;ja,&amp;done);CHKERRQ(ierr);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="preprocessor">#ifdef PETSC_HAVE_X11</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!rank) ierr = MatView(matloc,PETSC_VIEWER_DRAW_SELF);CHKERRQ(ierr);
<a name="l00140"></a>00140 <span class="preprocessor">#endif</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00142"></a>00142   ierr = MatDestroyMatrices(1,&amp;submatloc);CHKERRQ(ierr);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00145"></a>00145 }
<a name="l00146"></a>00146 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

